"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileUtils = void 0;
const fs_1 = require("fs");
const path_1 = require("path");
const interpolator_1 = require("./interpolator");
class FileUtils {
    static readJson(relativePath, parameters) {
        if (!relativePath) {
            return undefined;
        }
        const path = path_1.join(process.cwd(), relativePath);
        if (fs_1.existsSync(path)) {
            const fileContent = fs_1.readFileSync(path).toString();
            const interpolated = interpolator_1.Interpolator.interpolate(fileContent, parameters);
            return JSON.parse(interpolated);
        }
    }
    static mkdirIfNotExists(path) {
        if (!fs_1.existsSync(path)) {
            fs_1.mkdirSync(path);
        }
    }
    static writeFile(path, data) {
        fs_1.writeFileSync(path, data);
    }
}
exports.FileUtils = FileUtils;
